package org.xxx.yyy.application.repository;

import java.rmi.RemoteException;

import org.apache.axis2.AxisFault;
import org.openkm.wsgen.folder.AccessDeniedExceptionException2;
import org.openkm.wsgen.folder.DatabaseExceptionException1;
import org.openkm.wsgen.folder.ExtensionExceptionException5;
import org.openkm.wsgen.folder.ItemExistsExceptionException4;
import org.openkm.wsgen.folder.OKMFolderServiceStub;
import org.openkm.wsgen.folder.PathNotFoundExceptionException0;
import org.openkm.wsgen.folder.RepositoryExceptionException3;
import org.openkm.wsgen.folder.OKMFolderServiceStub.Create;
import org.openkm.wsgen.folder.OKMFolderServiceStub.CreateResponse;
import org.openkm.wsgen.propertygroup.AccessDeniedExceptionException3;
import org.openkm.wsgen.propertygroup.DatabaseExceptionException2;
import org.openkm.wsgen.propertygroup.IOExceptionException4;
import org.openkm.wsgen.propertygroup.LockExceptionException1;
import org.openkm.wsgen.propertygroup.NoSuchGroupExceptionException5;
import org.openkm.wsgen.propertygroup.NoSuchPropertyExceptionException8;
import org.openkm.wsgen.propertygroup.OKMPropertyGroupServiceStub;
import org.openkm.wsgen.propertygroup.ParseExceptionException6;
import org.openkm.wsgen.propertygroup.RepositoryExceptionException7;
import org.openkm.wsgen.propertygroup.OKMPropertyGroupServiceStub.AddGroup;
import org.openkm.wsgen.propertygroup.OKMPropertyGroupServiceStub.FormElementComplex;
import org.openkm.wsgen.propertygroup.OKMPropertyGroupServiceStub.FormElementComplexArray;
import org.openkm.wsgen.propertygroup.OKMPropertyGroupServiceStub.GetProperties;
import org.openkm.wsgen.propertygroup.OKMPropertyGroupServiceStub.GetPropertiesResponse;
import org.openkm.wsgen.propertygroup.OKMPropertyGroupServiceStub.SetProperties;

import org.xxx.yyy.repository.AuthException;
import org.xxx.yyy.repository.MetaData;
import org.xxx.yyy.repository.Repository;
import org.xxx.yyy.repository.RepositoryException;
import org.xxx.yyy.repository.RepositoryFactory;
import org.xxx.yyy.repository.okm.OkmRepositoryImpl;
import org.xxx.yyy.repository.okm.OpenKMHelper;
import org.xxx.yyy.repository.okm.OpenKMUtils;

public class WebServiceTest {
	
	private Repository repository;
	private static String loginToken;
	static OKMFolderServiceStub.Folder theFolder;
	
	private void setup() {
		repository = RepositoryFactory.getInstance("admin");
		loginToken = ((OkmRepositoryImpl) repository).getLoginToken();
	}
	
	private void createNewFolder() throws RemoteException, PathNotFoundExceptionException0, DatabaseExceptionException1, AccessDeniedExceptionException2, ItemExistsExceptionException4, ExtensionExceptionException5, RepositoryExceptionException3{
		OKMFolderServiceStub.Folder folder = new OKMFolderServiceStub.Folder();
		OKMFolderServiceStub okmFolderServiceStub = (OKMFolderServiceStub)OpenKMHelper.getStubFor(OpenKMUtils.URL_FOLDER);
		folder.setPath("/okm:root/test/user/testuser");
		Create createObj = new Create();
		CreateResponse respObj = null;
		createObj.setToken(loginToken);
		createObj.setFld(folder);
		try{
		respObj = okmFolderServiceStub.create(createObj);
		}catch(PathNotFoundExceptionException0 pe){
			pe.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
		}
		theFolder = respObj.get_return();
	}
	
	private void addFolderGroup() throws AxisFault{
		OKMPropertyGroupServiceStub okmPropertyGroupServiceStub = (OKMPropertyGroupServiceStub)OpenKMHelper.getStubFor(OpenKMUtils.URL_PROPERTY_GROUP);
		AddGroup groupObj = new AddGroup();
		groupObj.setToken(loginToken);
		groupObj.setNodePath(theFolder.getPath());
		groupObj.setGrpName("okg:folder");
		try {
			okmPropertyGroupServiceStub.addGroup(groupObj);
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (org.openkm.wsgen.propertygroup.PathNotFoundExceptionException0 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (LockExceptionException1 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (DatabaseExceptionException2 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (AccessDeniedExceptionException3 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchGroupExceptionException5 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RepositoryExceptionException7 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void addFolderProperties() throws AxisFault{
		//OKMPropertyGroupServiceStub.FormElementComplex stringArrayPairObj[] = new OKMPropertyGroupServiceStub.FormElementComplex[3];
		OKMPropertyGroupServiceStub.FormElementComplexArray stringArrayPairObj = new OKMPropertyGroupServiceStub.FormElementComplexArray();
		
		String ownerValue ="test";
		String ownerKey = OpenKMHelper.getRepositoryKeyForMetadataKey(MetaData.FOL_OWNER);
		stringArrayPairObj.addItem(wrapMetaData(ownerKey, ownerValue));

		// 2. title - maps to MetaData.FOL_TITLE
		String titleValue = "test";
		String titleKey = OpenKMHelper.getRepositoryKeyForMetadataKey(MetaData.FOL_TITLE);
		stringArrayPairObj.addItem(wrapMetaData(titleKey, titleValue));

		// 3. description - maps to MetaData.FOL_DESCRIPTION
		String descriptionValue = "sample description";
		String descriptionKey = OpenKMHelper.getRepositoryKeyForMetadataKey(MetaData.FOL_DESCRIPTION);
		stringArrayPairObj.addItem(wrapMetaData(descriptionKey, descriptionValue));
		
		//OKMPropertyGroupServiceStub.FormElementComplex stringArrayPairArrayObj = new OKMPropertyGroupServiceStub.FormElementComplex();
		//stringArrayPairArrayObj.setItem(stringArrayPairObj);
		
		SetProperties propertyObj = new SetProperties();
		propertyObj.setToken(loginToken);
		propertyObj.setNodePath(theFolder.getPath());
		propertyObj.setGrpName(OpenKMUtils.getInstance().readRepositoryProperties(OpenKMUtils.METADATA_FOLDER_GROUP));
		propertyObj.setProperties(stringArrayPairObj);
		
		OKMPropertyGroupServiceStub stub = new OKMPropertyGroupServiceStub();
		try {
			stub.setProperties(propertyObj);
			
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (org.openkm.wsgen.propertygroup.PathNotFoundExceptionException0 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (DatabaseExceptionException2 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOExceptionException4 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchGroupExceptionException5 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParseExceptionException6 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RepositoryExceptionException7 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (LockExceptionException1 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (AccessDeniedExceptionException3 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchPropertyExceptionException8 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
		
	}
	
	private void getFolderProperties() throws AxisFault{
		GetProperties getPropertyObj = new GetProperties();
		GetPropertiesResponse grpRespObj = null;
		OKMPropertyGroupServiceStub stub = new OKMPropertyGroupServiceStub();		
		FormElementComplexArray arr = new FormElementComplexArray();
		  getPropertyObj.setGrpName("okg:folder");
		  getPropertyObj.setNodePath(theFolder.getPath());
		  getPropertyObj.setToken(loginToken);
		  
		  try {
			grpRespObj = stub.getProperties(getPropertyObj);
			arr = grpRespObj.get_return();
		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (org.openkm.wsgen.propertygroup.PathNotFoundExceptionException0 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (DatabaseExceptionException2 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOExceptionException4 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchGroupExceptionException5 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ParseExceptionException6 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (RepositoryExceptionException7 e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
			if(null!=arr){
				FormElementComplex complex = null;
				for(int i=0;i<arr.getItem().length;i++){
					complex = arr.getItem()[i];
					System.out.print(complex.getLabel() +"--");
					System.out.print(complex.getName() +"-");
					System.out.println(complex.getObjClass()+"-");
					System.out.println(complex.getValue());
				}
			}
	}
	
	private OKMPropertyGroupServiceStub.FormElementComplex wrapMetaData(String key, String data) {
		OKMPropertyGroupServiceStub.FormElementComplex complexObj = new OKMPropertyGroupServiceStub.FormElementComplex();
		complexObj.setName(key);
		complexObj.setValue(data);
		return complexObj;
	}
	
	/**
	 * Logout from OpenKM
	 */
	private void disConnect() {
		try {
			if (repository.isConnected()) {
				repository.disConnect();
			}
		} catch (AuthException e) {
			e.printStackTrace();
		} catch (RepositoryException e) {
			e.printStackTrace();
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		WebServiceTest obj = null;
		try {
			obj = new WebServiceTest();
			// obj.testGetSubFolders();
			obj.setup();
			if(null == theFolder){
				  obj.createNewFolder();
				  obj.addFolderGroup();
				}
			obj.getFolderProperties();
			obj.addFolderProperties();
			obj.getFolderProperties();
			
		} catch(Exception e){
			e.printStackTrace();
		}finally {
			obj.disConnect();
		}

	}

}
